@ECHO OFF
CLS

Set Wide=Dominant aspect ratio:      1.9600

Rem change 1.9600 to the value needed for comskip widescreen detection 
Rem This value needs to be set by trial and error.  Take a know widescreen mpg and run comskip.  Look in the comskip log file for the value used for wide screen.

Set CUTDIR=c:\project\Converted
set CAPDIR=c:\Project\Misc
set VDir=c:\VirtualDub
SET WORKDIR=c:\PROJECT
set SDIR=c:\project\source

set DG="%WORKDIR%\DGIndex.exe"
set LM="%WORKDIR%\Lame.exe"
Set WV="%WORKDIR%\Wavemp3.exe"
set COMSKIP="%WORKDIR%\comskip.exe"
set VDUB="C:\VirtualDub\vdub.exe"
Set DC="%WORKDIR%\delaycut.exe"
Set BS="c:\Besweet\BeSweet.exe"
SET AVIWAV="%WORKDIR%\AVI2WAVCMD.exe"

set AVISYNTH1=LoadPlugin("%WORKDIR%\DGDecode.dll")
set AVISYNTH2=LoadPlugin("%WORKDIR%\SimpleResize.dll")
set AVISYNTH3=LoadPlugin("%WORKDIR%\Leakkerneldeint.dll")
set AVISYNTH4=LoadPlugin("%WORKDIR%\MSharpen.dll")








:LOOP
ECHO A. One-Pass --Maintain 4:3 content
ECHO B. One-Pass --Expand 4:3 content to widescreen
ECHO C. Two-Pass High Quality --Maintain 4:3 content
ECHO D. Two-Pass High Quality --Expand 4:3 content to widescreen

ECHO Q. Quit
:: SET /P prompts for input and sets the variable
:: to whatever the user types
SET Choice=
SET /P Choice=Type the letter and press Enter: 
:: The syntax in the next line extracts the substring
:: starting at 0 (the beginning) and 1 character long
IF NOT '%Choice%'=='' SET Choice=%Choice:~0,1%
ECHO.
:: /I makes the IF comparison case-insensitive
IF /I '%Choice%'=='A' GOTO ItemA
IF /I '%Choice%'=='B' GOTO ItemB
IF /I '%Choice%'=='C' GOTO ItemC
IF /I '%Choice%'=='D' GOTO ItemD

IF /I '%Choice%'=='Q' GOTO End
ECHO "%Choice%" is not valid. Please try again.
ECHO.
GOTO Loop

:ItemA
FOR %%f IN (%SDIR%\*.mpg) DO call :Convert %%f %CAPDIR%\%%~nf.mpg 1 M
GOTO Again

:ItemB
FOR %%f IN (%SDIR%\*.mpg) DO call :Convert %%f %CAPDIR%\%%~nf.mpg 1 E
GOTO Again

:ItemC
FOR %%f IN (%SDIR%\*.mpg) DO call :Convert %%f %CAPDIR%\%%~nf.mpg 2 M
GOTO Again

:ItemD
FOR %%f IN (%SDIR%\*.mpg) DO call :Convert %%f %CAPDIR%\%%~nf.mpg 2 E
GOTO Again

:Again
pause
CLS
GOTO Loop







:Convert

echo off

move %1 %2
echo %1 copy to %2


%VDUB% /c
%COMSKIP% %2
%DG% -IA=2 -FO=0  -OM=2 -AIF=[%2] -OF=[%~dpn2] -exit
FOR %%G IN (%CAPDIR%\*ms.mpa) DO %DC%  -auto -out %CAPDIR%\cutaudio.mpa "%%G"
"%BS%" -core( -input "%CAPDIR%\cutaudio.mpa" -output "%CAPDIR%\%~n2.wav" -2ch -logfilea "C:\besweet\BeSweet.log"  ) -profile( ~~~~~ Default Profile ~~~~~ )
del %CAPDIR%\*.mpa

rem 
%CAPDIR:~0,2%
REM Change working drive to CAPDIR's drive

cd %CAPDIR%
REM Change working directory to CAPDIR
 
echo %AVISYNTH1% >>"%CAPDIR%\%~n2.avs"
echo %AVISYNTH2% >>"%CAPDIR%\%~n2.avs"
echo %AVISYNTH3% >>"%CAPDIR%\%~n2.avs"
echo %AVISYNTH4% >>"%CAPDIR%\%~n2.avs"

findstr /c:"%wide%" %CAPDIR%\%~n2.log >%CAPDIR%\%~n2ar.txt

Set /P _Wide2=<%CAPDIR%\%~n2ar.txt
echo "%wide%" "%_wide2%"


if "%wide%" EQU "%_wide2%" (goto wide)  else (goto standard)

:standard
echo 4:3 screen
if %4 EQU M (goto :M)  else (goto :E)

:E
echo %4 Means expand 4:3 to 16:9
echo %3 pass
echo Video=MPEG2Source("%CAPDIR%\%~n2.d2v").LeakKernelDeint(1,10,false,false,false,false,false,0).lanczos4resize(688,508).crop(0,14,0,-14).addborders(16,0,16,0).panorama(3).MSharpen(20,130) >>"%CAPDIR%\%~n2.avs"
goto resume

:M
echo %4 Means maintain 4:3
echo %3 pass
echo Video=MPEG2Source("%CAPDIR%\%~n2.d2v").Crop(6, 6, -6, -6).LeakKernelDeint(1,10,false,false,false,false,false,0).LanczosResize(624,464).MSharpen(20,130) >>"%CAPDIR%\%~n2.avs"

goto resume

:wide
echo wide
Set _Wide2=standard
echo Video=MPEG2Source("%CAPDIR%\%~n2.d2v").Crop(6, 60, -6, -60).LeakKernelDeint(1,10,false,false,false,false,false,0).Lanczos4Resize(624,352).MSharpen(20,130) >>"%CAPDIR%\%~n2.avs"


:resume
echo audio = WAVSource("%CAPDIR%\%~n2.wav").normalize() >>"%CAPDIR%\%~n2.avs"
echo AudioDub(video, audio) >>"%CAPDIR%\%~n2.avs"



REM Define Panorama function

echo function Panorama(clip clp, int "strength") >>"%CAPDIR%\%~n2.avs"
echo { >>"%CAPDIR%\%~n2.avs"
echo #  >>"%CAPDIR%\%~n2.avs"
echo # function for converting 4:3 full frame clips to simulated 16:9 >>"%CAPDIR%\%~n2.avs"
echo # source vid should be 720x480 or 720x576 and have display AR of 4:3 >>"%CAPDIR%\%~n2.avs"
echo # script by Moth3r - originaltrilogy.com >>"%CAPDIR%\%~n2.avs"
echo #  >>"%CAPDIR%\%~n2.avs"
echo ht=clp.height >>"%CAPDIR%\%~n2.avs"
echo #  >>"%CAPDIR%\%~n2.avs"
echo a=(strength==1)?clp.lanczos4resize(256,ht,0,0,-660,0): \ >>"%CAPDIR%\%~n2.avs"
echo (strength==2)?clp.lanczos4resize(284,ht,0,0,-660,0): \ >>"%CAPDIR%\%~n2.avs"
echo (strength==3)?clp.lanczos4resize(308,ht,0,0,-660,0): \ >>"%CAPDIR%\%~n2.avs"
echo clp.lanczos4resize(332,ht,0,0,-660,0) >>"%CAPDIR%\%~n2.avs"
echo b=(strength==1)?clp.lanczos4resize(248,ht,60,0,-600,0): \ >>"%CAPDIR%\%~n2.avs"
echo (strength==2)?clp.lanczos4resize(260,ht,60,0,-600,0): \ >>"%CAPDIR%\%~n2.avs"
echo (strength==3)?clp.lanczos4resize(272,ht,60,0,-600,0): \ >>"%CAPDIR%\%~n2.avs"
echo clp.lanczos4resize(284,ht,60,0,-600,0) >>"%CAPDIR%\%~n2.avs"
echo c=clp.lanczos4resize(240,ht,120,0,-540,0) >>"%CAPDIR%\%~n2.avs"
echo d=(strength==1)?clp.lanczos4resize(236,ht,180,0,-480,0): \ >>"%CAPDIR%\%~n2.avs"
echo (strength==2)?clp.lanczos4resize(228,ht,180,0,-480,0): \ >>"%CAPDIR%\%~n2.avs"
echo (strength==3)?clp.lanczos4resize(220,ht,180,0,-480,0): \ >>"%CAPDIR%\%~n2.avs"
echo clp.lanczos4resize(212,ht,180,0,-480,0) >>"%CAPDIR%\%~n2.avs"
echo e=(strength==1)?clp.lanczos4resize(232,ht,240,0,-420,0): \ >>"%CAPDIR%\%~n2.avs"
echo (strength==2)?clp.lanczos4resize(216,ht,240,0,-420,0): \ >>"%CAPDIR%\%~n2.avs"
echo (strength==3)?clp.lanczos4resize(204,ht,240,0,-420,0): \ >>"%CAPDIR%\%~n2.avs"
echo clp.lanczos4resize(192,ht,240,0,-420,0) >>"%CAPDIR%\%~n2.avs"
echo f=(strength==1)?clp.lanczos4resize(456,ht,300,0,-300,0): \ >>"%CAPDIR%\%~n2.avs"
echo (strength==2)?clp.lanczos4resize(424,ht,300,0,-300,0): \ >>"%CAPDIR%\%~n2.avs"
echo (strength==3)?clp.lanczos4resize(392,ht,300,0,-300,0): \ >>"%CAPDIR%\%~n2.avs"
echo clp.lanczos4resize(360,ht,300,0,-300,0) >>"%CAPDIR%\%~n2.avs"
echo g=(strength==1)?clp.lanczos4resize(232,ht,420,0,-240,0): \ >>"%CAPDIR%\%~n2.avs"
echo (strength==2)?clp.lanczos4resize(216,ht,420,0,-240,0): \ >>"%CAPDIR%\%~n2.avs"
echo (strength==3)?clp.lanczos4resize(204,ht,420,0,-240,0): \ >>"%CAPDIR%\%~n2.avs"
echo clp.lanczos4resize(192,ht,420,0,-240,0) >>"%CAPDIR%\%~n2.avs"
echo h=(strength==1)?clp.lanczos4resize(236,ht,480,0,-180,0): \ >>"%CAPDIR%\%~n2.avs"
echo (strength==2)?clp.lanczos4resize(228,ht,480,0,-180,0): \ >>"%CAPDIR%\%~n2.avs"
echo (strength==3)?clp.lanczos4resize(220,ht,480,0,-180,0): \ >>"%CAPDIR%\%~n2.avs"
echo clp.lanczos4resize(212,ht,480,0,-180,0) >>"%CAPDIR%\%~n2.avs"
echo i=clp.lanczos4resize(240,ht,540,0,-120,0) >>"%CAPDIR%\%~n2.avs"
echo j=(strength==1)?clp.lanczos4resize(248,ht,600,0,-60,0): \ >>"%CAPDIR%\%~n2.avs"
echo (strength==2)?clp.lanczos4resize(260,ht,600,0,-60,0): \ >>"%CAPDIR%\%~n2.avs"
echo (strength==3)?clp.lanczos4resize(272,ht,600,0,-60,0): \ >>"%CAPDIR%\%~n2.avs"
echo clp.lanczos4resize(284,ht,600,0,-60,0) >>"%CAPDIR%\%~n2.avs"
echo k=(strength==1)?clp.lanczos4resize(256,ht,660,0,0,0): \ >>"%CAPDIR%\%~n2.avs"
echo (strength==2)?clp.lanczos4resize(284,ht,660,0,0,0): \ >>"%CAPDIR%\%~n2.avs"
echo (strength==3)?clp.lanczos4resize(308,ht,660,0,0,0): \ >>"%CAPDIR%\%~n2.avs"
echo clp.lanczos4resize(332,ht,660,0,0,0) >>"%CAPDIR%\%~n2.avs"
echo # >>"%CAPDIR%\%~n2.avs"
echo clp=StackHorizontal(a, b, c, d, e, f, g, h, i, j, k).crop(112,0,-112,0) >>"%CAPDIR%\%~n2.avs"
echo # >>"%CAPDIR%\%~n2.avs"
echo return clp.lanczos4resize(608,352) >>"%CAPDIR%\%~n2.avs"
echo } >>"%CAPDIR%\%~n2.avs"

REM Create AVS files
REM Add AVISynth commands to avs file created above.  Add more lines if required
REM Replace these example VirtualDub script commands here with your commands.  Add more variables if required.

echo VirtualDub.Open (u"%CAPDIR%\%~n2.avs"); > "%CAPDIR%\initial.txt"
type "%CAPDIR%\%~n2.vcf" >> "%CAPDIR%\initial.txt"
echo VirtualDub.audio.SetSource(1); >> "%CAPDIR%\initial.txt"
echo VirtualDub.audio.SetMode(0); >> "%CAPDIR%\initial.txt"
echo VirtualDub.audio.SetInterleave(1,500,1,0,0); >> "%CAPDIR%\initial.txt"
echo VirtualDub.audio.SetClipMode(1,1); >> "%CAPDIR%\initial.txt"
echo VirtualDub.audio.SetConversion(0,0,0,0,0); >> "%CAPDIR%\initial.txt"
echo VirtualDub.audio.SetVolume(); >> "%CAPDIR%\initial.txt"
echo VirtualDub.audio.SetCompression(); >> "%CAPDIR%\initial.txt"
echo VirtualDub.audio.EnableFilterGraph(0);>> "%CAPDIR%\initial.txt"
echo VirtualDub.video.SetInputFormat(0); >> "%CAPDIR%\initial.txt"
echo VirtualDub.video.SetOutputFormat(7); >> "%CAPDIR%\initial.txt"
echo VirtualDub.video.SetMode(1); >> "%CAPDIR%\initial.txt"
echo VirtualDub.video.SetFrameRate(0,1); >> "%CAPDIR%\initial.txt"
echo VirtualDub.video.SetIVTC(0,0,-1,0); >> "%CAPDIR%\initial.txt"
echo VirtualDub.video.SetRange(0,0); >> "%CAPDIR%\initial.txt"
echo VirtualDub.video.SetCompression(0x64697678,0,10000,0); >> "%CAPDIR%\initial.txt"

if %3 EQU 2 (goto :two)  else (goto :one)

:two
echo // > "%VDIR%\VirtualDub.jobs"
echo // $numjobs 2; >> "%VDIR%\VirtualDub.jobs"
echo // >> "%VDIR%\VirtualDub.jobs"
echo // $job "Job 1" >> "%VDIR%\VirtualDub.jobs"
echo // $input "%CAPDIR%\%~n2.avs" >> "%VDIR%\VirtualDub.jobs"
echo // $output "%CAPDIR%\%~n2.avi" >> "%VDIR%\VirtualDub.jobs"
echo // $state 0 >> "%VDIR%\VirtualDub.jobs"
echo // $start_time 0 0 >> "%VDIR%\VirtualDub.jobs"
echo // $end_time 0 0 >> "%VDIR%\VirtualDub.jobs"
echo // $script >> "%VDIR%\VirtualDub.jobs"
type "%CAPDIR%\initial.txt" >> "%VDIR%\VirtualDub.jobs"
type "%WORKDIR%\pass1.vcf" >> "%VDIR%\VirtualDub.jobs"
echo VirtualDub.video.filters.Clear(); >> "%VDIR%\VirtualDub.jobs"
echo VirtualDub.audio.filters.Clear(); >> "%VDIR%\VirtualDub.jobs"
echo VirtualDub.project.ClearTextInfo(); >> "%VDIR%\VirtualDub.jobs"
echo VirtualDub.SaveAVI (u"%CAPDIR%\%~n2.avi"); >> "%VDIR%\VirtualDub.jobs"
echo VirtualDub.audio.SetSource(1); >> "%VDIR%\VirtualDub.jobs"
echo VirtualDub.Close(); >> "%VDIR%\VirtualDub.jobs"
echo // $endjob  >> "%VDIR%\VirtualDub.jobs"
echo // >> "%VDIR%\VirtualDub.jobs" 
echo // $job "Job 2" >> "%VDIR%\VirtualDub.jobs"
echo // $input "%CAPDIR%\%~n2.avs" >> "%VDIR%\VirtualDub.jobs"
echo // $output "%CAPDIR%\%~n2.avi" >> "%VDIR%\VirtualDub.jobs"
echo // $state 0 >> "%VDIR%\VirtualDub.jobs"
echo // $start_time 0 0 >> "%VDIR%\VirtualDub.jobs"
echo // $end_time 0 0 >> "%VDIR%\VirtualDub.jobs"
echo // $script >> "%VDIR%\VirtualDub.jobs"
type "%CAPDIR%\initial.txt" >> "%VDIR%\VirtualDub.jobs"
type "%WORKDIR%\pass2.vcf" >> "%VDIR%\VirtualDub.jobs"
echo VirtualDub.video.filters.Clear(); >> "%VDIR%\VirtualDub.jobs"
echo VirtualDub.audio.filters.Clear(); >> "%VDIR%\VirtualDub.jobs"
echo VirtualDub.project.ClearTextInfo(); >> "%VDIR%\VirtualDub.jobs"
echo VirtualDub.SaveAVI (u"%CAPDIR%\%~n2.avi"); >> "%VDIR%\VirtualDub.jobs"
echo VirtualDub.audio.SetSource(1); >> "%VDIR%\VirtualDub.jobs"
echo VirtualDub.Close(); >> "%VDIR%\VirtualDub.jobs"
echo // $endjob >> "%VDIR%\VirtualDub.jobs"
echo // >> "%VDIR%\VirtualDub.jobs"
echo //-------------------------------------------------- >> "%VDIR%\VirtualDub.jobs"
echo // $done >> "%VDIR%\VirtualDub.jobs"

%VDUB% /r
goto :audio


:one

type "%CAPDIR%\initial.txt" > "%CAPDIR%\%~n2new.vcf"
type "%WORKDIR%\1pass.vcf" >> "%CAPDIR%\%~n2new.vcf"
echo VirtualDub.video.filters.Clear(); >> "%CAPDIR%\%~n2new.vcf"
echo VirtualDub.audio.filters.Clear(); >> "%CAPDIR%\%~n2new.vcf"
echo VirtualDub.SaveAVI (u"%CAPDIR%\%~n2.avi"); >> ""%CAPDIR%\%~n2new.vcf"

FOR %%G in (%CAPDIR%\*.avs) DO  %VDUB% /s "%CAPDIR%\%%~nGnew.vcf" 


:audio
del %CAPDIR%\*.wav
del %CAPDIR%\*.mp3 

@%VDUB% /i %WORKDIR%\extractwav.vcf %CAPDIR%\%~n2.avi %CAPDIR%\%~n2.wav

%LM% --preset cbr 192 "%CAPDIR%\%~n2.wav" "%CAPDIR%\%~n2.mp3"
%WV% -q "%CAPDIR%\%~n2.mp3"


echo VirtualDub.Open (u"%CAPDIR%\%~n2.avi"); > "%CAPDIR%\%~n2Audio.vcf"
echo VirtualDub.audio.SetSource (u"%CAPDIR%\%~n2.wav"); >> "%CAPDIR%\%~n2Audio.vcf"
echo VirtualDub.audio.SetMode(0); >> "%CAPDIR%\%~n2Audio.vcf"
echo VirtualDub.audio.SetInterleave(1,500,1,0,0); >> "%CAPDIR%\%~n2Audio.vcf"
echo VirtualDub.audio.SetClipMode(1,1); >> "%CAPDIR%\%~n2Audio.vcf"
echo VirtualDub.audio.SetConversion(0,0,0,0,0); >> "%CAPDIR%\%~n2Audio.vcf"
echo VirtualDub.audio.SetVolume(); >> "%CAPDIR%\%~n2Audio.vcf"
echo VirtualDub.audio.SetCompression(); >> "%CAPDIR%\%~n2Audio.vcf"
echo VirtualDub.audio.EnableFilterGraph(0); >> "%CAPDIR%\%~n2Audio.vcf"
echo VirtualDub.video.SetInputFormat(0); >> "%CAPDIR%\%~n2Audio.vcf"
echo VirtualDub.video.SetOutputFormat(7); >> "%CAPDIR%\%~n2Audio.vcf"
echo VirtualDub.video.SetMode(0); >> "%CAPDIR%\%~n2Audio.vcf"
echo VirtualDub.video.SetFrameRate(0,1); >> "%CAPDIR%\%~n2Audio.vcf"
echo VirtualDub.video.SetIVTC(0,0,-1,0); >> "%CAPDIR%\%~n2Audio.vcf"
echo VirtualDub.video.SetCompression(); >> "%CAPDIR%\%~n2Audio.vcf"
echo VirtualDub.video.filters.Clear(); >> "%CAPDIR%\%~n2Audio.vcf"
echo VirtualDub.audio.filters.Clear(); >> "%CAPDIR%\%~n2Audio.vcf"
echo VirtualDub.SaveAVI (u"%CUTDIR%\%~n2.avi"); >> "%CAPDIR%\%~n2Audio.vcf"

REM  Merge compressed audio with AVI


%VDUB% /s "%CAPDIR%\%~n2Audio.vcf" 

move %2 %SDIR%

del %CAPDIR%\*.avi
del %CAPDIR%\*.vcf
del %CAPDIR%\*.wav
del %CAPDIR%\*.mp3
rem del %CAPDIR%\*.mpg 
del %CAPDIR%\*.mpa
del %CAPDIR%\*.d2v
del %CAPDIR%\*.avs
del %CAPDIR%\*.txt


:End